//+------------------------------------------------------------------+
//|                                                 MomemtInTime.mq4 |
//|                                         Copyright  2010, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LeMan."
#property link      "b-market@mail.ru"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_color4     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_level1     0
#property indicator_levelcolor SlateGray
#property indicator_levelstyle STYLE_SOLID
   
extern string tm = "00:00";
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   IndicatorDigits(Digits);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer3);
   SetIndexBuffer(2,ExtMapBuffer4);
   SetIndexBuffer(3,ExtMapBuffer2); SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,159);
   SetIndexBuffer(4,trend);
   
   IndicatorShortName("MomemtInTime("+tm+")");   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (trend[limit]==-1) CleanPoint(limit,ExtMapBuffer3,ExtMapBuffer4);
           
   //
   //
   //
   //
   //
   
   double t = 0;  
   for(i=limit; i>=0; i--)
   {
      ExtMapBuffer2[i] = EMPTY_VALUE;
      if (TimeToStr(Time[i],TIME_MINUTES) == tm) {
         t = Open[i];
         ExtMapBuffer2[i] = 0;
      }
      ExtMapBuffer1[i] = NormalizeDouble(Close[i]-t, Digits);
   }
   
   for(i=limit; i>=0; i--)
   {
      ExtMapBuffer3[i] = EMPTY_VALUE;
      ExtMapBuffer4[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if (ExtMapBuffer1[i]>0) trend[i] = 1; 
      if (ExtMapBuffer1[i]<0) trend[i] =-1; 
      if (trend[i]==-1) PlotPoint(i,ExtMapBuffer3,ExtMapBuffer4,ExtMapBuffer1);
   }
   return(0);
  }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

